
#include "stdafx.h"
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <afxwin.h>  

#include "tcp4u.h"
#include "udp4u.h"
UINT UdpThreadProc(LPVOID pParam);
CWinThread* UdpThread;

int main(int argc, char* argv[])
{printf("Press any key to stop!\n");
 UdpThread=AfxBeginThread(UdpThreadProc,NULL);   
 _getch();
 return 0;
}

UINT UdpThreadProc(LPVOID pParam)  
{// Init two waveform
 int i;    
 char udporder[8];
 short data[1024];
 double fs,t1;
 fs=11025;               // Sample frequency is 11025 Hz
 for (i=0;i<1024;i++) 
 {t1=2*3.14*i*50.0/fs; 
  data[i]=(short)(1000*sin(t1));   // 100 Hz Sine wave
 } 
 // Create a UDP Server, which listen on 8888 
 short Rc;                
 LPUDPSOCK lpSock=NULL;
 if (Tcp4uInit()!=TCP4U_SUCCESS) return 0;
 Rc=UdpInit(&lpSock,NULL,0,8888);  
 if (Rc!=TCP4U_SUCCESS) 
   {Tcp4uCleanup();
    return 0;
	}   
 for (;Rc>=TCP4U_SUCCESS;)
  {
A: Rc=UdpRecv(lpSock,(char *)udporder,8,0,-1); 
   UdpBind(lpSock,TRUE,UDP4U_SERVER);
   Rc=UdpSend(lpSock,(char *)data,2048,0,-1);
   UdpBind(lpSock,FALSE,0);
   goto A;
 }
 if (lpSock!=NULL) 
 {UdpCleanup(lpSock);
  Tcp4uCleanup();
 } 
 return 0;
}
