// (C) 2000, Fernando Luis Cacciola Carballal.
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// You are welcome to contact the author at: fcacciola@fibertel.com.ar

// Shows how member templates can
// be used to provide a class with
// generic convertion capabilities.
// This class can be constructed
// with values of arbitrary types,
// and can be converted to
// arbitrary types as well.
struct variant0_t
{
  variant0_t():data(NULL){}

  template<typename T> variant0_t(const T& v)
   : data ( &v ) {}

  template<typename T> operator T () const
  { return * reinterpret_cast<const T*>(data); }

  const void* data ;
} ;
